%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016
%
function o=gaussIntWin(f,mu,sigma,wden)
b1=mu-5*sigma;
b2=mu+5*sigma;
ugauss=@(x) 1/sqrt(2*pi)*exp(-x.^2/2);
if isnumeric(wden)
    o=integral(@(z)f(z,wden).*ugauss((z-mu)./sigma),b1,b2);
else   
    o=integral2(@(z,w)f(z,w).*wden(w).*ugauss((z-mu)./sigma),b1,b2,-1,1);
end
end