%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016
%
function [GOLsim,specSim,failFlag]=mftNumericalSim(fp_vec,nwkParam,omega_vec)

g=nwkParam.g;
wden=nwkParam.wden;
phi=nwkParam.phi;
phip=nwkParam.phip;
N=nwkParam.N;
ii=1;
mxTryIter=100;
mxSlvIter=1000;

xinit=zeros(N,1);
xfp=zeros(N,length(fp_vec));

tic;

for iter=1:mxTryIter
    disp(['iter #' num2str(iter)]);
    W=g*randn(N)/sqrt(N); %weigth matrix initialization
    wf=mftNumericalSimRandWfb(N,wden);% generate random weights according to the distribution wden
    
    for ndx=1:length(fp_vec)
        A=fp_vec(ndx);
        [x1, failFlag]=mftNumericalSimFindX1( W,phi,A,wf,xinit,mxSlvIter);
        if ~failFlag
            xfp(:,ndx)=x1+wf*A; %combining the stochastic and the deterministic parts of the vector x
            disp(['solving point #' num2str(ndx)]);
        else
            disp('failed to converge, skipping this realization');
            break;
        end
    end
    if ~failFlag
        break
    end
end
if failFlag
    error('Failed to converge in numerical simulation');
end
rfp=phi(xfp);
wo=rfp/(rfp'*rfp)*fp_vec';
for ii=1:length(fp_vec);
    GOLsim{ii}=J15_sweepOmegaQk((W*diag(phip(xfp(:,ii)))-eye(N)),omega_vec,wf,wo.*phip(xfp(:,ii)));
    specSim{ii}=-1+eig((W+wf*wo')*diag(phip(xfp(:,ii))));
end
