%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function [ x, failFlag, iter ] = mftNumericalSimFindX1( W,f,A,win,xinit,maxiter,uin )
%This function computer the stochastic component of the state vector 
%x by successive numerical iterations
if nargin<7
    uin=zeros(size(win)); %extra input
end
xtol=1e-5;
x=xinit;
x_old=x+2;
iter=0;
while (max(abs(x-x_old))>xtol)&&(iter<maxiter)
    x_old=x;
    x=W*f(x+win*A+uin);
    iter=iter+1;
end

failFlag=(iter>=maxiter);



