%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function wfb=mftNumericalSimRandWfb(N,wden)
%Creates a vector of N elements distributed according to wden or, 
%if wden is a scalar creates a vectors with all entries equal to wden.
%wden mus have a support only between -1 and 1
%
%N-number of elements
%wden a probability density function (for weights)
if isnumeric(wden)
    wfb=ones(N,1)*wden;
else   
    wfb=zeros(N,1);
    t=-1:0.01:1;
    mxDen=max(wden(t));
    
    for i=1:N
        accepted=0;
        while ~accepted
            wfb(i)=2*rand-1; % generating a random number between -1 and 1 (uniformly)
            accepted=rand<(wden(wfb(i))/mxDen); %checking for acceptance w.r.t the distribution
        end
    end

end
