%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016
%
function [A_vec,nwkParam]=mftTrainPickFig(fig)
switch upper(fig)
    case '1A'
        A_vec=1;
        nwkParam.g=1.5;
        nwkParam.phi=@tanh;
        nwkParam.phip=(@(x) 1-tanh(x).^2);
    case '1B'
        A_vec=1;
        nwkParam.g=0.5;
        nwkParam.phi=@tanh;
        nwkParam.phip=(@(x) 1-tanh(x).^2);
    case '1C'
        A_vec=1;
        nwkParam.g=1.1;
        nwkParam.phi=(@(x) max(0,x-0.1));
        nwkParam.phip=(@(x) x>0.1);
    case '1D'
        A_vec=[0.5 1.0 1.5];
        nwkParam.g=1.0;
        nwkParam.phi=@tanh;
        nwkParam.phip=(@(x) 1-tanh(x).^2);
    case '2'
        A_vec=[0.5 1.0 1.5];
        nwkParam.g=0.9;
        nwkParam.phi=@tanh;
        nwkParam.phip=(@(x) 1-tanh(x).^2);
    otherwise
        error('Unknown figure reference. Legal options: 1a 1b 1c 1d 2');
end
nwkParam.N=3000; % this takes pretty much time to simulate. Use 1000 if no super-accuracy needed
nwkParam.wden=@(x)((x>=-1)&(x<=1))/2;

