%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function [alphaSys, beta0, beta1]=mftTrainSolveAlpha(A,nwkParam,sigma)

g=nwkParam.g;
wden=nwkParam.wden;
phi=nwkParam.phi;
phip=nwkParam.phip;

beta0=gaussIntWin((@(y,w) w.*phi(w*A+sigma*y).*phip(w*A+sigma*y)),0,1,wden)/sigma^2*g^2;
beta1=gaussIntWin((@(y,w) (sigma*y).*phi(w*A+sigma*y).*phip(w*A+sigma*y)),0,1,wden)/sigma^2*g^2;

alphaSys=minreal(beta0/(1-beta1)/...
    tf([1/(1-beta1) 1],1)/tf([1 1],1));
