%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function [cout,sigma1,sigma2]=mftTrainSolveCorr(A1,A2,nwkParam,sigma1,sigma2)

g=nwkParam.g;
wden=nwkParam.wden;
phi=nwkParam.phi;
phip=nwkParam.phip;

sigma1=fzero((@(s) g^2*gaussIntWin((@(y,w) phi(w*A1+s*y).^2),0,1,wden)-s^2),[0 100]);
sigma2=fzero((@(s) g^2*gaussIntWin((@(y,w) phi(w*A2+s*y).^2),0,1,wden)-s^2),[0 100]);

myOne=(@(x,y) ones(length(x),length(y)));
cout=fzero(...
    (@(c) g^2*gaussIntZ012((@(z1,z2,w) ...
    phi(w*A2+sigma2*(c*z1+sqrt(1-c^2)*z2)).*phi(w*A1+sigma1*z1)),myOne,wden)-sigma1*sigma2*c),...
    [-1 1]);
end