%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function [G21Sys]=mftTrainSolveGnm(A1,A2,nwkParam,c,s1,s2,alphaSys)

g=nwkParam.g;
wden=nwkParam.wden;
phi=nwkParam.phi;
phip=nwkParam.phip;

cc=sqrt(1-c^2);
r=phi;
rp=phip;
myOne=(@(x,y) ones(length(x),length(y)));

gamma0=gaussIntZ012((@(z1,z2,w) r(w*A2+s2*(c*z1+cc*z2)).*rp(w*A1+s1*z1).*w),myOne,wden)    *g^2;
gamma1=gaussIntZ012((@(z1,z2,w) r(w*A2+s2*(c*z1+cc*z2)).*rp(w*A1+s1*z1).*z1),myOne,wden)*s1*g^2;
gamma2=gaussIntZ012((@(z1,z2,w) r(w*A2+s2*(c*z1+cc*z2)).*rp(w*A1+s1*z1).*z2),myOne,wden)*s2*g^2;

gamma0p=gamma0/s2^2/cc;
gamma1p=gamma1/s2^2/cc;
gamma2p=gamma2/s2^2/cc;

d0sys=zpk(-1,[],1);
d1sys=minreal(d0sys*c*s1/cc/s2-gamma1p);
d2sys=zpk(-(1-gamma2p),[],1);
alpha21Sys=minreal((gamma0p/d0sys-d1sys*alphaSys)/d2sys);
G21Sys=minreal(c*s2*s1*alphaSys+cc*s2^2*alpha21Sys);

%% an alternative p-z calculation
% p1=1-beta1;
% p2=1-gamma2/cc/s2^2;
% z1=1-beta1+beta0*(gamma1/gamma0-c*s1*gamma2/cc/s2/gamma0);
