%This is a supplementary code for the paper "Local Dynamics in Trained
%Recurrent Neural Networks" by Alexander Rivkind and Omri Barak, 2016

function sigma=mftTrainSolveSigma(A1,nwkParam)
%computes sigma (of the field x) around a fixed point A1
g=nwkParam.g;
wden=nwkParam.wden;
phi=nwkParam.phi;
sigmaSelfConsistEq=(@(s) nwkParam.g^2*gaussIntWin((@(y,w) phi(w*A1+s*y).^2),0,1,wden)-s^2);
%precomputing a good range to look for solution
lowerLim=0;
lowerVal=sigmaSelfConsistEq(lowerLim);
for upperLim=100:-0.5:0.5
    upperVal=sigmaSelfConsistEq(upperLim);
    if upperVal*lowerVal<0 %should have opposite signs
        break
    end
end
%finding sigma self consistently
sigma=fzero(sigmaSelfConsistEq,[0.0 upperVal]);
